summaryrefslogtreecommitdiffstats
path: root/packaging
diff options
context:
space:
mode:
authorJames Mills <1290234+prologic@users.noreply.github.com>2020-01-17 01:12:02 +0200
committerGitHub <noreply@github.com>2020-01-17 01:12:02 +0200
commitc7e13846a87054d1e6e412d8edbc25b9dcbc684f (patch)
treeb93b52ed2b9d1aa886a86ee18a381349dc3f33a7 /packaging
parent8a3c7a7e7be13303709d8064f64a7efd5c361c8e (diff)
Fixes support for read-only /lib on SystemD systems like CoreOS in kickstart static64 (#7726)
* Fix formatting of functions.sh and errors found by shellcheck * Added support for other SystemD systems where /lib is read-only (e.g: CoreOS) * Fix minor typo(s)/grammar with safe_256sum() function * Fix shellcheck warnings in safe_256sum() function * Update the md5sum of the kickstart-static64.sh script in our docs to match
Diffstat (limited to 'packaging')
-rw-r--r--packaging/installer/README.md2
-rw-r--r--packaging/installer/functions.sh1256
-rwxr-xr-xpackaging/installer/kickstart-static64.sh8
3 files changed, 634 insertions, 632 deletions
diff --git a/packaging/installer/README.md b/packaging/installer/README.md
index 749641acf6..bdc2965637 100644
--- a/packaging/installer/README.md
+++ b/packaging/installer/README.md
@@ -116,7 +116,7 @@ This script installs Netdata at `/opt/netdata`.
Verify the integrity of the script with this:
```bash
-[ "9e0901736a8ed5ebcc84bc1c2c7b5db9" = "$(curl -Ss https://my-netdata.io/kickstart-static64.sh | md5sum | cut -d ' ' -f 1)" ] && echo "OK, VALID" || echo "FAILED, INVALID"
+[ "986e7756219717b075675ebe9b812916" = "$(curl -Ss https://my-netdata.io/kickstart-static64.sh | md5sum | cut -d ' ' -f 1)" ] && echo "OK, VALID" || echo "FAILED, INVALID"
```
*It should print `OK, VALID` if the script is the one we ship.*
diff --git a/packaging/installer/functions.sh b/packaging/installer/functions.sh
index d15494434f..b6830b1c7d 100644
--- a/packaging/installer/functions.sh
+++ b/packaging/installer/functions.sh
@@ -1,4 +1,5 @@
-# no shebang necessary - this is a library to be sourced
+#!/bin/bash
+
# SPDX-License-Identifier: GPL-3.0-or-later
# shellcheck disable=SC1091,SC1117,SC2002,SC2004,SC2034,SC2046,SC2059,SC2086,SC2129,SC2148,SC2154,SC2155,SC2162,SC2166,SC2181,SC2193
@@ -8,97 +9,97 @@
# -----------------------------------------------------------------------------
setup_terminal() {
- TPUT_RESET=""
- TPUT_BLACK=""
- TPUT_RED=""
- TPUT_GREEN=""
- TPUT_YELLOW=""
- TPUT_BLUE=""
- TPUT_PURPLE=""
- TPUT_CYAN=""
- TPUT_WHITE=""
- TPUT_BGBLACK=""
- TPUT_BGRED=""
- TPUT_BGGREEN=""
- TPUT_BGYELLOW=""
- TPUT_BGBLUE=""
- TPUT_BGPURPLE=""
- TPUT_BGCYAN=""
- TPUT_BGWHITE=""
- TPUT_BOLD=""
- TPUT_DIM=""
- TPUT_UNDERLINED=""
- TPUT_BLINK=""
- TPUT_INVERTED=""
- TPUT_STANDOUT=""
- TPUT_BELL=""
- TPUT_CLEAR=""
-
- # Is stderr on the terminal? If not, then fail
- test -t 2 || return 1
-
- if command -v tput 1>/dev/null 2>&1; then
- if [ $(($(tput colors 2>/dev/null))) -ge 8 ]; then
- # Enable colors
- TPUT_RESET="$(tput sgr 0)"
- TPUT_BLACK="$(tput setaf 0)"
- TPUT_RED="$(tput setaf 1)"
- TPUT_GREEN="$(tput setaf 2)"
- TPUT_YELLOW="$(tput setaf 3)"
- TPUT_BLUE="$(tput setaf 4)"
- TPUT_PURPLE="$(tput setaf 5)"
- TPUT_CYAN="$(tput setaf 6)"
- TPUT_WHITE="$(tput setaf 7)"
- TPUT_BGBLACK="$(tput setab 0)"
- TPUT_BGRED="$(tput setab 1)"
- TPUT_BGGREEN="$(tput setab 2)"
- TPUT_BGYELLOW="$(tput setab 3)"
- TPUT_BGBLUE="$(tput setab 4)"
- TPUT_BGPURPLE="$(tput setab 5)"
- TPUT_BGCYAN="$(tput setab 6)"
- TPUT_BGWHITE="$(tput setab 7)"
- TPUT_BOLD="$(tput bold)"
- TPUT_DIM="$(tput dim)"
- TPUT_UNDERLINED="$(tput smul)"
- TPUT_BLINK="$(tput blink)"
- TPUT_INVERTED="$(tput rev)"
- TPUT_STANDOUT="$(tput smso)"
- TPUT_BELL="$(tput bel)"
- TPUT_CLEAR="$(tput clear)"
- fi
- fi
-
- return 0
+ TPUT_RESET=""
+ TPUT_BLACK=""
+ TPUT_RED=""
+ TPUT_GREEN=""
+ TPUT_YELLOW=""
+ TPUT_BLUE=""
+ TPUT_PURPLE=""
+ TPUT_CYAN=""
+ TPUT_WHITE=""
+ TPUT_BGBLACK=""
+ TPUT_BGRED=""
+ TPUT_BGGREEN=""
+ TPUT_BGYELLOW=""
+ TPUT_BGBLUE=""
+ TPUT_BGPURPLE=""
+ TPUT_BGCYAN=""
+ TPUT_BGWHITE=""
+ TPUT_BOLD=""
+ TPUT_DIM=""
+ TPUT_UNDERLINED=""
+ TPUT_BLINK=""
+ TPUT_INVERTED=""
+ TPUT_STANDOUT=""
+ TPUT_BELL=""
+ TPUT_CLEAR=""
+
+ # Is stderr on the terminal? If not, then fail
+ test -t 2 || return 1
+
+ if command -v tput 1>/dev/null 2>&1; then
+ if [ $(($(tput colors 2>/dev/null))) -ge 8 ]; then
+ # Enable colors
+ TPUT_RESET="$(tput sgr 0)"
+ TPUT_BLACK="$(tput setaf 0)"
+ TPUT_RED="$(tput setaf 1)"
+ TPUT_GREEN="$(tput setaf 2)"
+ TPUT_YELLOW="$(tput setaf 3)"
+ TPUT_BLUE="$(tput setaf 4)"
+ TPUT_PURPLE="$(tput setaf 5)"
+ TPUT_CYAN="$(tput setaf 6)"
+ TPUT_WHITE="$(tput setaf 7)"
+ TPUT_BGBLACK="$(tput setab 0)"
+ TPUT_BGRED="$(tput setab 1)"
+ TPUT_BGGREEN="$(tput setab 2)"
+ TPUT_BGYELLOW="$(tput setab 3)"
+ TPUT_BGBLUE="$(tput setab 4)"
+ TPUT_BGPURPLE="$(tput setab 5)"
+ TPUT_BGCYAN="$(tput setab 6)"
+ TPUT_BGWHITE="$(tput setab 7)"
+ TPUT_BOLD="$(tput bold)"
+ TPUT_DIM="$(tput dim)"
+ TPUT_UNDERLINED="$(tput smul)"
+ TPUT_BLINK="$(tput blink)"
+ TPUT_INVERTED="$(tput rev)"
+ TPUT_STANDOUT="$(tput smso)"
+ TPUT_BELL="$(tput bel)"
+ TPUT_CLEAR="$(tput clear)"
+ fi
+ fi
+
+ return 0
}
setup_terminal || echo >/dev/null
progress() {
- echo >&2 " --- ${TPUT_DIM}${TPUT_BOLD}${*}${TPUT_RESET} --- "
+ echo >&2 " --- ${TPUT_DIM}${TPUT_BOLD}${*}${TPUT_RESET} --- "
}
# -----------------------------------------------------------------------------
netdata_banner() {
- local l1=" ^" \
- l2=" |.-. .-. .-. .-. .-. .-. .-. .-. .-. .-. .-. .-. .-" \
- l3=" | '-' '-' '-' '-' '-' '-' '-' '-' '-' '-' '-' '-' " \
- l4=" +----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+--->" \
- sp=" " \
- netdata="netdata" start end msg="${*}" chartcolor="${TPUT_DIM}"
+ local l1=" ^" \
+ l2=" |.-. .-. .-. .-. .-. .-. .-. .-. .-. .-. .-. .-. .-" \
+ l3=" | '-' '-' '-' '-' '-' '-' '-' '-' '-' '-' '-' '-' " \
+ l4=" +----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+--->" \
+ sp=" " \
+ netdata="netdata" start end msg="${*}" chartcolor="${TPUT_DIM}"
- [ ${#msg} -lt ${#netdata} ] && msg="${msg}${sp:0:$((${#netdata} - ${#msg}))}"
- [ ${#msg} -gt $((${#l2} - 20)) ] && msg="${msg:0:$((${#l2} - 23))}..."
+ [ ${#msg} -lt ${#netdata} ] && msg="${msg}${sp:0:$((${#netdata} - ${#msg}))}"
+ [ ${#msg} -gt $((${#l2} - 20)) ] && msg="${msg:0:$((${#l2} - 23))}..."
- start="$((${#l2} / 2 - 4))"
- [ $((start + ${#msg} + 4)) -gt ${#l2} ] && start=$((${#l2} - ${#msg} - 4))
- end=$((start + ${#msg} + 4))
+ start="$((${#l2} / 2 - 4))"
+ [ $((start + ${#msg} + 4)) -gt ${#l2} ] && start=$((${#l2} - ${#msg} - 4))
+ end=$((start + ${#msg} + 4))
- echo >&2
- echo >&2 "${chartcolor}${l1}${TPUT_RESET}"
- echo >&2 "${chartcolor}${l2:0:start}${sp:0:2}${TPUT_RESET}${TPUT_BOLD}${TPUT_GREEN}${netdata}${TPUT_RESET}${chartcolor}${sp:0:$((end - start - 2 - ${#netdata}))}${l2:end:$((${#l2} - end))}${TPUT_RESET}"
- echo >&2 "${chartcolor}${l3:0:start}${sp:0:2}${TPUT_RESET}${TPUT_BOLD}${TPUT_CYAN}${msg}${TPUT_RESET}${chartcolor}${sp:0:2}${l3:end:$((${#l2} - end))}${TPUT_RESET}"
- echo >&2 "${chartcolor}${l4}${TPUT_RESET}"
- echo >&2
+ echo >&2
+ echo >&2 "${chartcolor}${l1}${TPUT_RESET}"
+ echo >&2 "${chartcolor}${l2:0:start}${sp:0:2}${TPUT_RESET}${TPUT_BOLD}${TPUT_GREEN}${netdata}${TPUT_RESET}${chartcolor}${sp:0:$((end - start - 2 - ${#netdata}))}${l2:end:$((${#l2} - end))}${TPUT_RESET}"
+ echo >&2 "${chartcolor}${l3:0:start}${sp:0:2}${TPUT_RESET}${TPUT_BOLD}${TPUT_CYAN}${msg}${TPUT_RESET}${chartcolor}${sp:0:2}${l3:end:$((${#l2} - end))}${TPUT_RESET}"
+ echo >&2 "${chartcolor}${l4}${TPUT_RESET}"
+ echo >&2
}
# -----------------------------------------------------------------------------
@@ -109,225 +110,225 @@ rcservice_cmd="$(command -v rc-service 2>/dev/null)"
systemctl_cmd="$(command -v systemctl 2>/dev/null)"
service() {
- local cmd="${1}" action="${2}"
-
- if [ -n "${systemctl_cmd}" ]; then
- run "${systemctl_cmd}" "${action}" "${cmd}"
- return $?
- elif [ -n "${service_cmd}" ]; then
- run "${service_cmd}" "${cmd}" "${action}"
- return $?
- elif [ -n "${rcservice_cmd}" ]; then
- run "${rcservice_cmd}" "${cmd}" "${action}"
- return $?
- fi
- return 1
+ local cmd="${1}" action="${2}"
+
+ if [ -n "${systemctl_cmd}" ]; then
+ run "${systemctl_cmd}" "${action}" "${cmd}"
+ return $?
+ elif [ -n "${service_cmd}" ]; then
+ run "${service_cmd}" "${cmd}" "${action}"
+ return $?
+ elif [ -n "${rcservice_cmd}" ]; then
+ run "${rcservice_cmd}" "${cmd}" "${action}"
+ return $?
+ fi
+ return 1
}
# -----------------------------------------------------------------------------
# portable pidof
safe_pidof() {
- local pidof_cmd="$(command -v pidof 2>/dev/null)"
- if [ -n "${pidof_cmd}" ]; then
- ${pidof_cmd} "${@}"
- return $?
- else
- ps -acxo pid,comm |
- sed "s/^ *//g" |
- grep netdata |
- cut -d ' ' -f 1
- return $?
- fi
+ local pidof_cmd="$(command -v pidof 2>/dev/null)"
+ if [ -n "${pidof_cmd}" ]; then
+ ${pidof_cmd} "${@}"
+ return $?
+ else
+ ps -acxo pid,comm |
+ sed "s/^ *//g" |
+ grep netdata |
+ cut -d ' ' -f 1
+ return $?
+ fi
}
# -----------------------------------------------------------------------------
find_processors() {
- local cpus
- if [ -f "/proc/cpuinfo" ]; then
- # linux
- cpus=$(grep -c ^processor /proc/cpuinfo)
- else
- # freebsd
- cpus=$(sysctl hw.ncpu 2>/dev/null | grep ^hw.ncpu | cut -d ' ' -f 2)
- fi
- if [ -z "${cpus}" ] || [ $((cpus)) -lt 1 ]; then
- echo 1
- else
- echo "${cpus}"
- fi
+ local cpus
+ if [ -f "/proc/cpuinfo" ]; then
+ # linux
+ cpus=$(grep -c ^processor /proc/cpuinfo)
+ else
+ # freebsd
+ cpus=$(sysctl hw.ncpu 2>/dev/null | grep ^hw.ncpu | cut -d ' ' -f 2)
+ fi
+ if [ -z "${cpus}" ] || [ $((cpus)) -lt 1 ]; then
+ echo 1
+ else
+ echo "${cpus}"
+ fi
}
# -----------------------------------------------------------------------------
fatal() {
- printf >&2 "${TPUT_BGRED}${TPUT_WHITE}${TPUT_BOLD} ABORTED ${TPUT_RESET} ${*} \n\n"
- exit 1
+ printf >&2 "${TPUT_BGRED}${TPUT_WHITE}${TPUT_BOLD} ABORTED ${TPUT_RESET} ${*} \n\n"
+ exit 1
}
run_ok() {
- printf >&2 "${TPUT_BGGREEN}${TPUT_WHITE}${TPUT_BOLD} OK ${TPUT_RESET} ${*} \n\n"
+ printf >&2 "${TPUT_BGGREEN}${TPUT_WHITE}${TPUT_BOLD} OK ${TPUT_RESET} ${*} \n\n"
}
run_failed() {
- printf >&2 "${TPUT_BGRED}${TPUT_WHITE}${TPUT_BOLD} FAILED ${TPUT_RESET} ${*} \n\n"
+ printf >&2 "${TPUT_BGRED}${TPUT_WHITE}${TPUT_BOLD} FAILED ${TPUT_RESET} ${*} \n\n"
}
ESCAPED_PRINT_METHOD=
printf "%q " test >/dev/null 2>&1
[ $? -eq 0 ] && ESCAPED_PRINT_METHOD="printfq"
escaped_print() {
- if [ "${ESCAPED_PRINT_METHOD}" = "printfq" ]; then
- printf "%q " "${@}"
- else
- printf "%s" "${*}"
- fi
- return 0
+ if [ "${ESCAPED_PRINT_METHOD}" = "printfq" ]; then
+ printf "%q " "${@}"
+ else
+ printf "%s" "${*}"
+ fi
+ return 0
}
run_logfile="/dev/null"
run() {
- local user="${USER--}" dir="${PWD}" info info_console
-
- if [ "${UID}" = "0" ]; then
- info="[root ${dir}]# "
- info_console="[${TPUT_DIM}${dir}${TPUT_RESET}]# "
- else
- info="[${user} ${dir}]$ "
- info_console="[${TPUT_DIM}${dir}${TPUT_RESET}]$ "
- fi
+ local user="${USER--}" dir="${PWD}" info info_console
+
+ if [ "${UID}" = "0" ]; then
+ info="[root ${dir}]# "
+ info_console="[${TPUT_DIM}${dir}${TPUT_RESET}]# "
+ else
+ info="[${user} ${dir}]$ "
+ info_console="[${TPUT_DIM}${dir}${TPUT_RESET}]$ "
+ fi
- printf >>"${run_logfile}" "${info}"
- escaped_print >>"${run_logfile}" "${@}"
- printf >>"${run_logfile}" " ... "
+ printf >>"${run_logfile}" "${info}"
+ escaped_print >>"${run_logfile}" "${@}"
+ printf >>"${run_logfile}" " ... "
- printf >&2 "${info_console}${TPUT_BOLD}${TPUT_YELLOW}"
- escaped_print >&2 "${@}"
- printf >&2 "${TPUT_RESET}\n"
+ printf >&2 "${info_console}${TPUT_BOLD}${TPUT_YELLOW}"
+ escaped_print >&2 "${@}"
+ printf >&2 "${TPUT_RESET}\n"
- "${@}"
+ "${@}"
- local ret=$?
- if [ ${ret} -ne 0 ]; then
- run_failed
- printf >>"${run_logfile}" "FAILED with exit code ${ret}\n"
- else
- run_ok
- printf >>"${run_logfile}" "OK\n"
- fi
+ local ret=$?
+ if [ ${ret} -ne 0 ]; then
+ run_failed
+ printf >>"${run_logfile}" "FAILED with exit code ${ret}\n"
+ else
+ run_ok
+ printf >>"${run_logfile}" "OK\n"
+ fi
- return ${ret}
+ return ${ret}
}
iscontainer() {
- # man systemd-detect-virt
- local cmd=$(command -v systemd-detect-virt 2>/dev/null)
- if [ -n "${cmd}" ] && [ -x "${cmd}" ]; then
- "${cmd}" --container >/dev/null 2>&1 && return 0
- fi
-
- # /proc/1/sched exposes the host's pid of our init !
- # http://stackoverflow.com/a/37016302
- local pid=$(cat /proc/1/sched 2>/dev/null | head -n 1 | {
- IFS='(),#:' read name pid th threads
- echo "$pid"
- })
- if [ -n "${pid}" ]; then
- pid=$(( pid + 0 ))
- [ ${pid} -gt 1 ] && return 0
- fi
-
- # lxc sets environment variable 'container'
- [ -n "${container}" ] && return 0
-
- # docker creates /.dockerenv
- # http://stackoverflow.com/a/25518345
- [ -f "/.dockerenv" ] && return 0
-
- # ubuntu and debian supply /bin/running-in-container
- # https://www.apt-browse.org/browse/ubuntu/trusty/main/i386/upstart/1.12.1-0ubuntu4/file/bin/running-in-container
- if [ -x "/bin/running-in-container" ]; then
- "/bin/running-in-container" >/dev/null 2>&1 && return 0
- fi
-
- return 1
+ # man systemd-detect-virt
+ local cmd=$(command -v systemd-detect-virt 2>/dev/null)
+ if [ -n "${cmd}" ] && [ -x "${cmd}" ]; then
+ "${cmd}" --container >/dev/null 2>&1 && return 0
+ fi
+
+ # /proc/1/sched exposes the host's pid of our init !
+ # http://stackoverflow.com/a/37016302
+ local pid=$(cat /proc/1/sched 2>/dev/null | head -n 1 | {
+ IFS='(),#:' read name pid th threads
+ echo "$pid"
+ })
+ if [ -n "${pid}" ]; then
+ pid=$((pid + 0))
+ [ ${pid} -gt 1 ] && return 0
+ fi
+
+ # lxc sets environment variable 'container'
+ [ -n "${container}" ] && return 0
+
+ # docker creates /.dockerenv
+ # http://stackoverflow.com/a/25518345
+ [ -f "/.dockerenv" ] && return 0
+
+ # ubuntu and debian supply /bin/running-in-container
+ # https://www.apt-browse.org/browse/ubuntu/trusty/main/i386/upstart/1.12.1-0ubuntu4/file/bin/running-in-container
+ if [ -x "/bin/running-in-container" ]; then
+ "/bin/running-in-container" >/dev/null 2>&1 && return 0
+ fi
+
+ return 1
}
issystemd() {
- local pids p myns ns systemctl
+ local pids p myns ns systemctl
- # if the directory /lib/systemd/system OR /usr/lib/systemd/system (SLES 12.x) does not exit, it is not systemd
- [ ! -d /lib/systemd/system -a ! -d /usr/lib/systemd/system ] && return 1
+ # if the directory /lib/systemd/system OR /usr/lib/systemd/system (SLES 12.x) does not exit, it is not systemd
+ [ ! -d /lib/systemd/system -a ! -d /usr/lib/systemd/system ] && return 1
- # if there is no systemctl command, it is not systemd
- # shellcheck disable=SC2230
- systemctl=$(command -v systemctl 2>/dev/null)
- [ -z "${systemctl}" -o ! -x "${systemctl}" ] && return 1
+ # if there is no systemctl command, it is not systemd
+ # shellcheck disable=SC2230
+ systemctl=$(command -v systemctl 2>/dev/null)
+ [ -z "${systemctl}" -o ! -x "${systemctl}" ] && return 1
- # if pid 1 is systemd, it is systemd
- [ "$(basename $(readlink /proc/1/exe) 2>/dev/null)" = "systemd" ] && return 0
+ # if pid 1 is systemd, it is systemd
+ [ "$(basename $(readlink /proc/1/exe) 2>/dev/null)" = "systemd" ] && return 0
- # if systemd is not running, it is not systemd
- pids=$(safe_pidof systemd 2>/dev/null)
- [ -z "${pids}" ] && return 1
+ # if systemd is not running, it is not systemd
+ pids=$(safe_pidof systemd 2>/dev/null)
+ [ -z "${pids}" ] && return 1
- # check if the running systemd processes are not in our namespace
- myns="$(readlink /proc/self/ns/pid 2>/dev/null)"
- for p in ${pids}; do
- ns="$(readlink "/proc/${p}/ns/pid" 2>/dev/null)"
+ # check if the running systemd processes are not in our namespace
+ myns="$(readlink /proc/self/ns/pid 2>/dev/null)"
+ for p in ${pids}; do
+ ns="$(readlink "/proc/${p}/ns/pid" 2>/dev/null)"
- # if pid of systemd is in our namespace, it is systemd
- [ -n "${myns}" ] && [ "${myns}" = "${ns}" ] && return 0
- done
+ # if pid of systemd is in our namespace, it is systemd
+ [ -n "${myns}" ] && [ "${myns}" = "${ns}" ] && return 0
+ done
- # else, it is not systemd
- return 1
+ # else, it is not systemd
+ return 1
}
install_non_systemd_init() {
- [ "${UID}" != 0 ] && return 1
-
- local key="unknown"
- if [ -f /etc/os-release ]; then
- source /etc/os-release || return 1
- key="${ID}-${VERSION_ID}"
-
- elif [ -f /etc/redhat-release ]; then
- key=$(</etc/redhat-release)
- fi
-
- if [ -d /etc/init.d ] && [ ! -f /etc/init.d/netdata ]; then
- if [[ ${key} =~ ^(gentoo|alpine).* ]]; then
- echo >&2 "Installing OpenRC init file..."
- run cp system/netdata-openrc /etc/init.d/netdata &&
- run chmod 755 /etc/init.d/netdata &&
- run rc-update add netdata default &&
- return 0
-
- elif [[ "${key}" =~ ^devuan* ]] || [ "${key}" = "debian-7" ] || [ "${key}" = "ubuntu-12.04" ] || [ "${key}" = "ubuntu-14.04" ]; then
- echo >&2 "Installing LSB init file..."
- run cp system/netdata-lsb /etc/init.d/netdata &&
- run chmod 755 /etc/init.d/netdata &&
- run update-rc.d netdata defaults &&
- run update-rc.d netdata enable &&
- return 0
- elif [[ ${key} =~ ^(amzn-201[5678]|ol|CentOS release 6|Red Hat Enterprise Linux Server release 6|Scientific Linux CERN SLC release 6|CloudLinux Server release 6).* ]]; then
- echo >&2 "Installing init.d file..."
- run cp system/netdata-init-d /etc/init.d/netdata &&
- run chmod 755 /etc/init.d/netdata &&
- run chkconfig netdata on &&
- return 0
- else
- echo >&2 "I don't know what init file to install on system '${key}'. Open a github issue to help us fix it."
- return 1
- fi
- elif [ -f /etc/init.d/netdata ]; then
- echo >&2 "file '/etc/init.d/netdata' already exists."
- return 0
- else
- echo >&2 "I don't know what init file to install on system '${key}'. Open a github issue to help us fix it."
- fi
-
- return 1
+ [ "${UID}" != 0 ] && return 1
+
+ local key="unknown"
+ if [ -f /etc/os-release ]; then
+ source /etc/os-release || return 1
+ key="${ID}-${VERSION_ID}"
+
+ elif [ -f /etc/redhat-release ]; then
+ key=$(</etc/redhat-release)
+ fi
+
+ if [ -d /etc/init.d ] && [ ! -f /etc/init.d/netdata ]; then
+ if [[ ${key} =~ ^(gentoo|alpine).* ]]; then
+ echo >&2 "Installing OpenRC init file..."
+ run cp system/netdata-openrc /etc/init.d/netdata &&
+ run chmod 755 /etc/init.d/netdata &&
+ run rc-update add netdata default &&
+ return 0
+
+ elif [[ ${key} =~ ^devuan* ]] || [ "${key}" = "debian-7" ] || [ "${key}" = "ubuntu-12.04" ] || [ "${key}" = "ubuntu-14.04" ]; then
+ echo >&2 "Installing LSB init file..."
+ run cp system/netdata-lsb /etc/init.d/netdata &&
+ run chmod 755 /etc/init.d/netdata &&
+ run update-rc.d netdata defaults &&
+ run update-rc.d netdata enable &&
+ return 0
+ elif [[ ${key} =~ ^(amzn-201[5678]|ol|CentOS release 6|Red Hat Enterprise Linux Server release 6|Scientific Linux CERN SLC release 6|CloudLinux Server release 6).* ]]; then
+ echo >&2 "Installing init.d file..."
+ run cp system/netdata-init-d /etc/init.d/netdata &&
+ run chmod 755 /etc/init.d/netdata &&
+ run chkconfig netdata on &&
+ return 0
+ else
+ echo >&2 "I don't know what init file to install on system '${key}'. Open a github issue to help us fix it."
+ return 1
+ fi
+ elif [ -f /etc/init.d/netdata ]; then
+ echo >&2 "file '/etc/init.d/netdata' already exists."
+ return 0
+ else
+ echo >&2 "I don't know what init file to install on system '${key}'. Open a github issue to help us fix it."
+ fi
+
+ return 1
}
NETDATA_START_CMD="netdata"
@@ -336,513 +337,514 @@ NETDATA_INSTALLER_START_CMD=""
NETDATA_INSTALLER_STOP_CMD="${NETDATA_STOP_CMD}"
install_netdata_service() {
- local uname="$(uname 2>/dev/null)"
-
- if [ "${UID}" -eq 0 ]; then
- if [ "${uname}" = "Darwin" ]; then
-
- if [ -f "/Library/LaunchDaemons/com.github.netdata.plist" ]; then
- echo >&2 "file '/Library/LaunchDaemons/com.github.netdata.plist' already exists."
- return 0
- else
- echo >&2 "Installing MacOS X plist file..."
- run cp system/netdata.plist /Library/LaunchDaemons/com.github.netdata.plist &&
- run launchctl load /Library/LaunchDaemons/com.github.netdata.plist &&
- return 0
- fi
-
- elif [ "${uname}" = "FreeBSD" ]; then
-
- run cp system/netdata-freebsd /etc/rc.d/netdata && NETDATA_START_CMD="service netdata start" &&
- NETDATA_STOP_CMD="service netdata stop" &&
- NETDATA_INSTALLER_START_CMD="service netdata onestart" &&
- NETDATA_INSTALLER_STOP_CMD="${NETDATA_STOP_CMD}"
- myret=$?
-
- echo >&2 "Note: To explicitly enable netdata automatic start, set 'netdata_enable' to 'YES' in /etc/rc.conf"
- echo >&2 ""
-
- return ${myret}
-
- elif issystemd; then
- # systemd is running on this system
- NETDATA_START_CMD="systemctl start netdata"
- NETDATA_STOP_CMD="systemctl stop netdata"
- NETDATA_INSTALLER_START_CMD="${NETDATA_START_CMD}"
- NETDATA_INSTALLER_STOP_CMD="${NETDATA_STOP_CMD}"
-
- SYSTEMD_DIRECTORY=""
-
- if [ -d "/lib/systemd/system" ]; then
- SYSTEMD_DIRECTORY="/lib/systemd/system"
- elif [ -d "/usr/lib/systemd/system" ]; then
- SYSTEMD_DIRECTORY="/usr/lib/systemd/system"
- fi
-
- if [ "${SYSTEMD_DIRECTORY}x" != "x" ]; then
- ENABLE_NETDATA_IF_PREVIOUSLY_ENABLED="run systemctl enable netdata"
- IS_NETDATA_ENABLED="$(systemctl is-enabled netdata 2> /dev/null || echo "Netdata not there")"
- if [ "${IS_NETDATA_ENABLED}" == "disabled" ]; then
- echo >&2 "Netdata was there and disabled, make sure we don't re-enable it ourselves"
- ENABLE_NETDATA_IF_PREVIOUSLY_ENABLED="true"
- fi
-
- echo >&2 "Installing systemd service..."
- run cp system/netdata.service "${SYSTEMD_DIRECTORY}/netdata.service" &&
- run systemctl daemon-reload &&
- ${ENABLE_NETDATA_IF_PREVIOUSLY_ENABLED} &&
- return 0
- else
- echo >&2 "no systemd directory; cannot install netdata.service"
- fi
- else
- install_non_systemd_init
- local ret=$?
-
- if [ ${ret} -eq 0 ]; then
- if [ -n "${service_cmd}" ]; then
- NETDATA_START_CMD="service netdata start"
- NETDATA_STOP_CMD="service netdata stop"
- elif [ -n "${rcservice_cmd}" ]; then
- NETDATA_START_CMD="rc-service netdata start"
- NETDATA_STOP_CMD="rc-service netdata stop"
- fi
- NETDATA_INSTALLER_START_CMD="${NETDATA_START_CMD}"
- NETDATA_INSTALLER_STOP_CMD="${NETDATA_STOP_CMD}"
- fi
-
- return ${ret}
- fi
- fi
-
- return 1
+ local uname="$(uname 2>/dev/null)"
+
+ if [ "${UID}" -eq 0 ]; then
+ if [ "${uname}" = "Darwin" ]; then
+
+ if [ -f "/Library/LaunchDaemons/com.github.netdata.plist" ]; then
+ echo >&2 "file '/Library/LaunchDaemons/com.github.netdata.plist' already exists."
+ return 0
+ else
+ echo >&2 "Installing MacOS X plist file..."
+ run cp system/netdata.plist /Library/LaunchDaemons/com.github.netdata.plist &&
+ run launchctl load /Library/LaunchDaemons/com.github.netdata.plist &&
+ return 0
+ fi
+
+ elif [ "${uname}" = "FreeBSD" ]; then
+
+ run cp system/netdata-freebsd /etc/rc.d/netdata && NETDATA_START_CMD="service netdata start" &&
+ NETDATA_STOP_CMD="service netdata stop" &&
+ NETDATA_INSTALLER_START_CMD="service netdata onestart" &&
+ NETDATA_INSTALLER_STOP_CMD="${NETDATA_STOP_CMD}"
+ myret=$?
+
+ echo >&2 "Note: To explicitly enable netdata automatic start, set 'netdata_enable' to 'YES' in /etc/rc.conf"
+ echo >&2 ""
+
+ return ${myret}
+
+ elif issystemd; then
+ # systemd is running on this system
+ NETDATA_START_CMD="systemctl start netdata"
+ NETDATA_STOP_CMD="systemctl stop netdata"
+ NETDATA_INSTALLER_START_CMD="${NETDATA_START_CMD}"
+ NETDATA_INSTALLER_STOP_CMD="${NETDATA_STOP_CMD}"
+
+ SYSTEMD_DIRECTORY=""
+
+ if [ -w "/lib/systemd/system" ]; then
+ SYSTEMD_DIRECTORY="/lib/systemd/system"
+ elif [ -w "/usr/lib/systemd/system" ]; then
+ SYSTEMD_DIRECTORY="/usr/lib/systemd/system"
+ elif [ -w "/etc/systemd/system" ]; then
+ SYSTEM_DIRECTORY="/etc/systemd/system"
+ fi
+
+ if [ "${SYSTEMD_DIRECTORY}x" != "x" ]; then
+ ENABLE_NETDATA_IF_PREVIOUSLY_ENABLED="run systemctl enable netdata"
+ IS_NETDATA_ENABLED="$(systemctl is-enabled netdata 2>/dev/null || echo "Netdata not there")"
+ if [ "${IS_NETDATA_ENABLED}" == "disabled" ]; then
+ echo >&2 "Netdata was there and disabled, make sure we don't re-enable it ourselves"
+ ENABLE_NETDATA_IF_PREVIOUSLY_ENABLED="true"
+ fi
+
+ echo >&2 "Installing systemd service..."
+ run cp system/netdata.service "${SYSTEMD_DIRECTORY}/netdata.service" &&
+ run systemctl daemon-reload &&
+ ${ENABLE_NETDATA_IF_PREVIOUSLY_ENABLED} &&
+ return 0
+ else
+ echo >&2 "no systemd directory; cannot install netdata.service"
+ fi
+ else
+ install_non_systemd_init
+ local ret=$?
+
+ if [ ${ret} -eq 0 ]; then
+ if [ -n "${service_cmd}" ]; then
+ NETDATA_START_CMD="service netdata start"
+ NETDATA_STOP_CMD="service netdata stop"
+ elif [ -n "${rcservice_cmd}" ]; then
+ NETDATA_START_CMD="rc-service netdata start"
+ NETDATA_STOP_CMD="rc-service netdata stop"
+ fi
+ NETDATA_INSTALLER_START_CMD="${NETDATA_START_CMD}"
+ NETDATA_INSTALLER_STOP_CMD="${NETDATA_STOP_CMD}"
+ fi
+
+ return ${ret}
+ fi
+ fi
+
+ return 1
}
# -----------------------------------------------------------------------------
# stop netdata
pidisnetdata() {
- if [ -d /proc/self ]; then
- [ -z "$1" -o ! -f "/proc/$1/stat" ] && return 1
- [ "$(cut -d '(' -f 2 "/proc/$1/stat" | cut -d ')' -f 1)" = "netdata" ] && return 0
- return 1
- fi
- return 0
+ if [ -d /proc/self ]; then
+ [ -z "$1" -o ! -f "/proc/$1/stat" ] && return 1
+ [ "$(cut -d '(' -f 2 "/proc/$1/stat" | cut -d ')' -f 1)" = "netdata" ] && return 0
+ return 1
+ fi
+ return 0
}
stop_netdata_on_pid() {
- local pid="${1}" ret=0 count=0
+ local pid="${1}" ret=0 count=0
- pidisnetdata "${pid}" || return 0
+ pidisnetdata "${pid}" || return 0
- printf >&2 "Stopping netdata on pid %s ..." "${pid}"
- while [ -n "$pid" ] && [ ${ret} -eq 0 ]; do
- if [ ${count} -gt 24 ]; then
- echo >&2 "Cannot stop the running netdata on pid ${pid}."
- return 1
- fi
+ printf >&2 "Stopping netdata on pid %s ..." "${pid}"
+ while [ -n "$pid" ] && [ ${ret} -eq 0 ]; do
+ if [ ${count} -gt 24 ]; then
+ echo >&2 "Cannot stop the running netdata on pid ${pid}."
+ return 1
+ fi
- count=$((count + 1))
+ count=$((count + 1))
- pidisnetdata "${pid}" || ret=1
- if [ ${ret} -eq 1 ] ; then
- break
- fi
+ pidisnetdata "${pid}" || ret=1
+ if [ ${ret} -eq 1 ]; then
+ break
+ fi
- if [ ${count} -lt 12 ] ; then
- run kill "${pid}" 2>/dev/null
- ret=$?
- else
- run kill -9 "${pid}" 2>/dev/null
- ret=$?
- fi
+ if [ ${count} -lt 12 ]; then
+ run kill "${pid}" 2>/dev/null
+ ret=$?
+ else
+ run kill -9 "${pid}" 2>/dev/null
+ ret=$?
+ fi
- test ${ret} -eq 0 && printf >&2 "." && sleep 5
+ test ${ret} -eq 0 && printf >&2 "." && sleep 5
- done
+ done
- echo >&2
- if [ ${ret} -eq 0 ]; then
- echo >&2 "SORRY! CANNOT STOP netdata ON PID ${pid} !"
- return 1
- fi
+ echo >&2
+ if [ ${ret} -eq 0 ]; then
+ echo >&2 "SORRY! CANNOT STOP netdata ON PID ${pid} !"
+ return 1
+ fi
- echo >&2 "netdata on pid ${pid} stopped."
- return 0
+ echo >&2 "netdata on pid ${pid} stopped."
+ return 0
}
netdata_pids() {
- local p myns ns
+ local p myns ns
- myns="$(readlink /proc/self/ns/pid 2>/dev/null)"
+ myns="$(readlink /proc/self/ns/pid 2>/dev/null)"
- for p in \
- $(cat /var/run/netdata.pid 2>/dev/null) \
- $(cat /var/run/netdata/netdata.pid 2>/dev/null) \
- $(safe_pidof netdata 2>/dev/null); do
- ns="$(readlink "/proc/${p}/ns/pid" 2>/dev/null)"
+ for p in \
+ $(cat /var/run/netdata.pid 2>/dev/null) \
+ $(cat /var/run/netdata/netdata.pid 2>/dev/null) \
+ $(safe_pidof netdata 2>/dev/null); do
+ ns="$(readlink "/proc/${p}/ns/pid" 2>/dev/null)"
- if [ -z "${myns}" ] || [ -z "${ns}" ] || [ "${myns}" = "${ns}" ]; then
- pidisnetdata "${p}" && echo "${p}"
- fi
- done
+ if [ -z "${myns}" ] || [ -z "${ns}" ] || [ "${myns}" = "${ns}" ]; then
+ pidisnetdata "${p}" && echo "${p}"
+ fi
+ done
}
stop_all_netdata() {
- local p
+ local p
- if [ -n "$(netdata_pids)" -a -n "$(builtin type -P netdatacli)" ] ; then
- netdatacli shutdown-agent
- sleep 20
- fi
+ if [ -n "$(netdata_pids)" -a -n "$(builtin type -P netdatacli)" ]; then
+ netdatacli shutdown-agent
+ sleep 20
+ fi
- for p in $(netdata_pids); do
- # shellcheck disable=SC2086
- stop_netdata_on_pid ${p}
- done
+ for p in $(netdata_pids); do
+ # shellcheck disable=SC2086
+ stop_netdata_on_pid ${p}
+ done
}
# -----------------------------------------------------------------------------
# restart netdata
restart_netdata() {
- local netdata="${1}"
- shift
+ local netdata="${1}"
+ shift
- local started=0
+ local started=0
- progress "Restarting netdata instance"
+ progress "Restarting netdata instance"
- if [ -z "${NETDATA_INSTALLER_START_CMD}" ] ; then
- NETDATA_INSTALLER_START_CMD="${netdata}"
- fi
+ if [ -z "${NETDATA_INSTALLER_START_CMD}" ]; then
+ NETDATA_INSTALLER_START_CMD="${netdata}"
+ fi
- if [ "${UID}" -eq 0 ]; then
- echo >&2
- echo >&2 "Stopping all netdata threads"
- run stop_all_netdata
+ if [ "${UID}" -eq 0 ]; then
+ echo >&2
+ echo >&2 "Stopping all netdata threads"
+ run stop_all_netdata
- echo >&2 "Starting netdata using command '${NETDATA_INSTALLER_START_CMD}'"
- run ${NETDATA_INSTALLER_START_CMD} && started=1
+ echo >&2 "Starting netdata using command '${NETDATA_INSTALLER_START_CMD}'"
+ run ${NETDATA_INSTALLER_START_CMD} && started=1
- if [ ${started} -eq 1 ] && [ -z "$(netdata_pids)" ]; then
- echo >&2 "Ooops! it seems netdata is not started."
- started=0
- fi
+ if [ ${started} -eq 1 ] && [ -z "$(netdata_pids)" ]; then
+ echo >&2 "Ooops! it seems netdata is not started."
+ started=0
+ fi
- if [ ${started} -eq 0 ]; then
- echo >&2 "Attempting another netdata start using command '${NETDATA_INSTALLER_START_CMD}'"
- run ${NETDATA_INSTALLER_START_CMD} && started=1
- fi
- fi
+ if [ ${started} -eq 0 ]; then
+ echo >&2 "Attempting another netdata start using command '${NETDATA_INSTALLER_START_CMD}'"
+ run ${NETDATA_INSTALLER_START_CMD} && started=1
+ fi
+ fi